/****************************************
 *					*
 * EEPROM write proaram to H8/3048F	*
 *	Copyleft Yukio Mituiwa,1998	*
 *					*
 ****************************************/

#define	LINUX
#undef	FreeBSD

#include	<stdio.h>
#include	<sys/stat.h>
#include	<unistd.h>
#include	<fcntl.h>
#define	RSLINE	"/dev/ttyS0"
#ifdef LINUX
 #include <termios.h>
 #define sgttyb termios
 #define stty(fd,term) tcsetattr(fd,TCSANOW,term)
#endif
#ifdef FreeBSD
 #include <sgtty.h>
#endif

unsigned char sPort[256], fileName[256], rsbuf[0xc00];
struct sgttyb TheTty;
int TheFd;
FILE *fp;

int putbyte(int c) {
	int	s;

	rsbuf[0] = c;
	if((s = write(TheFd,rsbuf,1)) == -1) {
		fprintf(stderr, "write error\n" );
		exit(-1);
	}
	return s;
}	

int getb() {
	int	s;

	if((s = read(TheFd,rsbuf,1)) == -1) {
		fprintf(stderr, "read error\n" );
		exit(-1);
	}
	return s;
}	

int getbyte() {
	int	s;

	do {
		if((s = read(TheFd,rsbuf,1)) == -1) {
			fprintf(stderr, "read error\n" );
			exit(-1);
		}
	} while(s < 1);
	return rsbuf[0];
}	

void bytecheck(char c,char data) {
	if(c != data) {
		fprintf(stderr, "H8 data %02X ignore!\n",(int)c );
		exit(-1);
	}
}

int main(argc,argv)
char **argv;
{
	int	i, c, n, s, addr, h;
	char	buffer[257], numbuf[17], *data;
	struct stat fileinfo;
	
	strcpy(sPort,RSLINE);
	switch(argc) {
	case 1:
		fprintf(stderr, "h8tool Motrola-SFile [ serial-port ]\n");
		return -1;
	case 3:
		strcpy(sPort,argv[2]);
	case 2:
		strcpy(fileName,argv[1]);
		break;
	default:
		fprintf(stderr, "option error!!\n");
		return -1;
	}

	if((TheFd=open( sPort , O_RDWR)) == -1){
		fprintf(stderr, "can't open %s\n", sPort);
		return -1;
	}
#ifdef LINUX
	tcsetpgrp(TheFd,getpgrp());
	tcgetattr(TheFd,&TheTty);
	cfsetispeed(&TheTty,9600);
	cfsetospeed(&TheTty,9600);
	TheTty.c_cflag |= HUPCL | CLOCAL ;
	TheTty.c_cflag &= ~( PARENB | CSTOPB );
	cfmakeraw(&TheTty);
#endif
#ifdef FreeBSD
	TheTty.sg_ispeed=B9600;
	TheTty.sg_ospeed=B9600;
	TheTty.sg_flags=RAW;
#endif
	if(stty(TheFd, &TheTty ) == -1){
		fprintf(stderr, "stty error\n" );
		return -1;
	}

	for(i = 0;i < 64;i++) buffer[i] = 0;
	do {
		if((s = write(TheFd,buffer,64)) == -1) {
			fprintf(stderr, "write error\n" );
			exit(-1);
		}
		s = getb();
	} while(s < 1);
return;
	bytecheck(rsbuf[0], 0);
	putbyte(0x55);
	do {
		s = getbyte();
	} while(s < 1);
	bytecheck(rsbuf[0], 0xaa);
	fprintf(stderr,"H8/3048F is ready!  1999/1/8 Yukio Mituiwa.\n");
	putbyte(0x0c);getbyte();
	putbyte(0x00);getbyte();
	if((fp = fopen("/usr/bin/romwrite.bin","r")) == NULL) {
		fprintf(stderr, "romwrite.bin not installed!\n" );
		exit(-1);
	}
	fread(rsbuf,0xc00,1,fp);
	write(TheFd,rsbuf,0xc00);
	n = 0;
	do {
		s = read(TheFd,rsbuf,0xc00);
		n += s;
	} while(n < 0xc00);
	fclose(fp);
	if(getbyte() == 0xaa) {
		puts("EEPROM writing program transfer successed.");
	}
	else {
		puts("EEPROM writing program transfer failed!");
		exit(-1);
	}

	if((fp = fopen(fileName,"r")) == NULL) {
		fprintf(stderr,"file not found!\n");
		exit(-1);
	}
	printf("writing");
	fscanf(fp,"%256s",buffer);
	while(!feof(fp)) {
		if(buffer[1] == '2' && buffer[0] == 'S') {
			for(i = 0;i < 2;i++) numbuf[i] = buffer[i + 2];
			numbuf[i] = '\0';
			sscanf(numbuf,"%X",&s); s = s - 4;
			for(i = 0;i < 6;i++) numbuf[i] = buffer[i + 4];
			numbuf[i] = '\0';
			sscanf(numbuf,"%X",&addr);
			putbyte(addr >> 16);
			putbyte((addr >> 8) & 0xff);
			putbyte(addr & 0xff);
			putbyte(s >> 16);
			putbyte((s >> 8) & 0xff);
			putbyte(s & 0xff);
			data = buffer + 10;
			for(i = 0;i < s;i++) {
				numbuf[0] = *(data++);
				numbuf[1] = *(data++);
				numbuf[2] = '\0';
				sscanf(numbuf,"%X",&h);
				putbyte(h);
			}
			if(getbyte() != 'S') {
				fprintf(stderr,"\nEEPROM Writing is failed!\n");
				exit(-1);
			}
			putchar('.');
			fflush(stdout);
		}
		fscanf(fp,"%256s",buffer);
	}
	fclose(fp);
	fprintf(stderr,"\nEEPROM Writing is successed.\n");
}