/* Copyleft,1999,Yukio Mituiwa */
#include "h8regdef.h"
#define WDTE		#0xa57f
#define WDTD		#0xa500
#define H8CLOCK		16
#define CONST_A		(H8CLOCK*25)/10+1
#define CONST_B		(H8CLOCK*7)/10+1
#define CONST_G		(H8CLOCK*9)/10+1

;;;	int writebyte(void *addr, unsigned char value)
;;;	0 is success
;;;	-1 is fail
;					address is er0
;					data is r1l  
	.h8300h
	.section .text
	.align 1
	.global _writebyte
_writebyte:
	mov.l	er0,er2
	shlr	er2
	shlr	er2
	shlr	er2
	shlr	er2
	shlr	er2
	shlr	er2
	mov.b	#0,r1h
	bset	r2h,r1h			; Set EBR1 bits
	mov.b	#1, r2l			; Program-verify fail count
	mov.w	#CONST_G, e1		; Set loop counter
	bset	#6,@FLMCR:8		; Bitset VppE
.l1:	dec.w	#1, e1
	bpl	.l1
	mov.b	r1h, @EBR1:8		; Set EBR1
	mov.b	r1l, @er0 		; Dummy write
	mov.w	#CONST_A, e2 		; Set initial program loop counter value
PRGMS:	mov.w	WDTE,e1
	mov.w	e1,@TCSR:16		; Start watchdog timer
	mov.w	e2,e1
	bset	#0,@FLMCR:8		; Bitset P
.l2:	dec.w	#1, e1
	bpl	.l2
	bclr	#0,@FLMCR:8		; Birclear P
	mov.w	WDTD,e1
	mov.w	e1, @TCSR:16	 	; Stop watchdog timer
	bset	#2,@FLMCR:8		; Bitset VP
	mov.w	#CONST_B,e1		; Set program-verify loop counter
.l3:	dec.w	#1,e1 			; Wait
	bpl	.l3
	mov.b	@er0,r2h
	cmp.b	r2h,r1l 
	beq	PVOK 			; Program-verify decision
PVNG:	bclr	#2,@FLMCR:8
	cmp.b	#06, r2l		; Program-verify executed 6 times?
	beq	NGEND 			; If program-verify executed 6 times, branch to NGEND
	inc.b	r2l			; Program-verify fail count + 1 @ R0L
	shll.w	e2			; Double program loop counter value
	bra	PRGMS 			; Program again
NGEND:	mov.w	#-1,r0			; Return values is -1
	bra	PRGME
PVOK:	bclr	#2,@FLMCR:8
	mov.w	#0,r0			; Return value is 0
PRGME:	mov.b	#0,r1l
	mov.b	r1l,@EBR1:8
	bclr	#6,@FLMCR:8
	rts
	.end
