/* server.c */

#include <stdio.h>
#include <netdb.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <sys/socket.h>
#include <signal.h>
#include <sys/stat.h>
#include <sys/ipc.h>
#include <sys/shm.h>
static int sigval;
#define SH_ID	200

/* 顼ɽ򤷤ơåȤĤơ۾ｪλ */
void err(int sock) {
	static	int n = 0;

	fprintf(stderr, "Error!! %d \n", n++);
	if(sock != -1) close(sock);
	exit(-1);
}

/* ǥХɥ饤зͳI/OݡȤ˥ǡϤ */
int putport(int num, int data) {
	char dev[16];
	FILE	*fp;

	sprintf(dev, "/dev/pio%d", num);
	if((fp = fopen(dev, "w")) == NULL) return -1;
	fprintf(fp, ".%02x", data & 0xff);
	fclose(fp);
	return 0;
}

/* ǥХɥ饤зͳI/OݡȤǡ */
int getport(int num, int *data) {
	char dev[16], number[4];
	int c;
	FILE	*fp;

	sprintf(dev, "/dev/pio%d", num);
	if((fp = fopen(dev, "r")) == NULL) return -1;
	while(fgetc(fp) != '.');
	number[0] = (char)fgetc(fp);
	number[1] = (char)fgetc(fp);
	number[2] = 0;
	sscanf(number, "%x", data);
	fclose(fp);
	return 0;
}

/* 饤ȤΥåȤ̵ˤʤä˸ƽФ */
void client_close(int sock) {
	close(sigval);		/* ФǤΥ饤̿åȤĤ */
	printf("Client socket is closed.\n");
	sigval = 0;
}

int main() {
	struct sockaddr_in servaddr;
	int servaddr_size;
	struct hostent *hostinfo;
	struct servent *servinfo;
	int	n, i, sock, cursock, port, data, ret, shmid;
	char	sendbuf[256], recvbuf[256], com[256], *shmem;

	/* ͭꥭ鶦ͭID */
	if(shmget(SH_ID, 0, 0) == -1) {
		/* ꤬ͭޤ¸ߤʤϡͭ򿷵 */
		if((shmid = shmget(SH_ID, 1, IPC_CREAT | S_IRUSR | S_IWUSR)) == -1) {
			fprintf(stderr, "shared memory get error!!\n"); exit(-1);
		}
	} else {
		/* ꤬ͭǤ¸ߤϡ礷ƤΤǽλ */
		fprintf(stderr, "already running!!\n"); exit(-1);
	}
	/* ͭID鶦ͭꥢɥ쥹 */
	if((shmem = shmat(shmid, NULL, 0)) == (char*)-1) {
		/* ۾ｪλξ϶ͭ˴ */
		shmctl(shmid, IPC_RMID, NULL);
		fprintf(stderr, "internal error!!\n"); exit(-1);
	}
	*shmem = 0;				/* ͭν */
	servaddr_size = sizeof(servaddr);
	servaddr.sin_family = AF_INET;		/* 󥿡ͥåб */
	/* ۥ̾ͥåȥɥ쥹 */
	hostinfo = gethostbyname("pc2.elec.edu");
	servaddr.sin_addr.s_addr = ((struct in_addr*)(hostinfo->h_addr))->s_addr;
	/* ݡ̾ݡֹ */
	servinfo = getservbyname("pio", "tcp");
	servaddr.sin_port = servinfo->s_port;
	/* ФTCPݡѥåȤ */
	if((sock = socket(AF_INET, SOCK_STREAM, 0)) == -1) err(sock);
	/* ФTCPݡȤݤ */
	if(bind(sock, &servaddr, servaddr_size) == -1) err(sock);
	/* 饤ȤΥåȤ̵ˤʤäclient_closeؿƽФ */
	signal(SIGPIPE, client_close);
	while(*shmem == 0) {
		/* 饤Ȥ׵1Ĥǽˤ */
		listen(sock, 1);
		/* 饤Ȥ׵դ */
		if((cursock = accept(sock, &servaddr, &servaddr_size)) == -1) err(sock);
		sigval = cursock;
		/* 饤Ȥ˽å */
		sprintf(sendbuf, "Welcome to pio Protocol.\n");
		n = strlen(sendbuf);
		sendbuf[n] = 0;
		send(cursock, sendbuf, n + 1, 0);
		do {
			/* 饤ȤΥޥɤ */
			n = recv(cursock, recvbuf, 256, 0);
			recvbuf[n] = 0;
			sscanf(recvbuf, "%s %d %x", com, &port, &data);
			/* 顼å򥻥å */
			strcpy(sendbuf, "Command not found!\n");
			/* putޥɤν */
			if(strcmp(com, "put") == 0) {
				ret = putport(port, data);
				strcpy(sendbuf, (ret == 0) ? "OK\n" : "ERR\n");
			/* getޥɤν */
			} else if(strcmp(com, "get") == 0) {
				ret = getport(port, &data);
				if(ret == -1) strcpy(sendbuf, "ERR");
				else sprintf(sendbuf, "%x\n", data);
			/* helpޥɤν */
			} else if(strcmp(com, "help") == 0) {
				strcpy(sendbuf, "put [port] [data]  /  get [port]  /  help  /  quit  \n");
			}
			/* 饤Ȥ˥ޥɤη̤ */
			n = strlen(sendbuf);
			sendbuf[n] = 0;
			send(cursock, sendbuf, n + 1, 0);
		} while(sigval > 0);
	}
	close(cursock);				/* 饤ȥåȤĤ */
	close(sock);				/* ФTCPݡȤ */
	printf("server socket is closed.\n");
	shmdt(shmem);				/* ͭȤ */
	shmctl(shmid, IPC_RMID, NULL);		/* ͭ˴ */
}
