/**************************************/
/* H8/3067FEEPROM񤭹ߥץ */
/* Copyleft,2001,Yukio Mituiwa        */
/**************************************/

#include "../reg3067.h"
int	write_block(char*, char*);

/* SCIν */
void sci_init() {
	int	i;

	SCR1 = 0;
	SMR1 = 0;
	BRR1 = 64;	/* 20MHz */
	for(i = 0;i < 280;i++);
	SCR1 = 0x30;
	SSR1 &= 0x87;
}

/* ꥢݡȤɤ߹ */
int read(char *buf, int size) {
	int	i;

	for(i = 0;i < size;i++) {
		while(!(SSR1 & 0x78));
		if(SSR1 & 0x40) {
			buf[i] = RDR1;
			SSR1 &= ~0x40;
		} else {
			SSR1 = 0xc7;
			return -1;
		}
	}
	return 0;
}

/* ꥢݡȤؽ񤭹 */
void write(char *buf, int size) {
	int	i;

	for(i = 0;i < size;i++) {
		while(!(SSR1 & 0x80));
		TDR1 = buf[i];
		SSR1 &= ~0x80;
	}
	while(!(SSR1 & 0x04));
}

int main(void) {
	char	buffer[32], *addr;
	int	i, n;

	sci_init();
	while(1) {
		read(buffer, 2);		   /* 񤭹ߥХ(2Х) */
		n = (unsigned int)buffer[0];
		n <<= 8;
		n += (unsigned int)buffer[1];
		n <<= 5;
		addr = (char*)n;
		read(buffer, 32);
		n = write_block(addr, buffer); /* EEPROM˥ǡ񤭹 */
		write(addr, 32);
		buffer[0] = (n == 0) ? 'S' : 'F';
		write(buffer, 1);
	}
}
