#include "../reg3067.h"
#define	wait_micro(mi_sec) for(wait = 0;wait < mi_sec * 2;wait++)

void write_pulse(int micro) {
	register int wait;

	TCSR = 0x5ac0; 		/* 12 [mS] ---- TCNT write */
	SYSCR &= ~0x80;
				/* 01111xxx  ----  WDT and TMD is enabled */
	TCSR = 0xa57f;		/* xxxxx111  ----  clock x 4096(0.2mS)	*/
	FLMCR |= 0x10;		/* PSU <- 1 	*/
	wait_micro(50);		/* wait 50[uS] 	*/
	FLMCR |= 0x01;		/* P <- 1, programing start 	*/
	wait_micro(micro);	/* wait 	*/
	FLMCR &= ~0x01;		/* P <- 0, programing stop 	*/
	wait_micro(10);		/* wait 10[uS]	*/
	FLMCR &= ~0x10;		/* PSU <- 0 	*/
	wait_micro(10);		/* wait 10[uS] 	*/
	TCSR = 0xa51f;		/* 00011xxx ---- WDT and TMD is disabled */
}

int write_block(char *dst, char *src) {
	static	char	rewrite[32], data;
	static	int	i, n, m;
	register char	*verify;
	register int	wait;

	P4DDR = 0xff;
	FLMCR |= 0x40;					/* SWE <- 1 */
	wait_micro(10);					/* wait 10[uS] */
	for(i = 0;i < 32;i++) rewrite[i] = src[i];
	n = 0;
	do {
		n++;
		m = 0;
		for(i = 0;i < 32;i++) dst[i] = rewrite[i]; /* program */
		write_pulse((n <= 4) ? 150 : 500);
		FLMCR |= 0x04;				/* PV <- 1 */
		wait_micro(4);				/* wait 4[uS] */
		verify = dst;
		for(i = 0;i < 32;i++) {
			*verify = 0xff;			/* dummy write */
			wait_micro(2);			/* wait 2[uS] */
			data = *verify;
			if(data != src[i]) m = 1;	/* verify data */
			rewrite[i] = src[i] | ~data;
			verify++;
		}
		FLMCR &= ~0x04;				/* PV <- 0* /
		wait_micro(4);				/* wait 4[uS] */
		if(n > 403) {
			FLMCR &= ~0x40;			/* SWE <- 0 */
			wait_micro(100);		/* wait 100[uS] */
			return -1;			/* ERROR!! */
		}
	} while(m != 0);
	FLMCR &= ~0x40;					/* SWE <- 0 */
	wait_micro(100);				/* wait 100[uS] */
	return 0;
}
