/********************************/
/* H8/3664FΥץץ */
/* Copyleft,2001,Yukio Mituiwa  */
/********************************/
#include <string.h>
#include "../reg3664.h"
#include "ne2000.h"
static char	hextbl[] = "0123456789ABCDEF";
static char	test_message[21] = "NE2000 test message.";
static char	test_buffer[21];
static char	mac_address[6];
static char	eeprom[32];
static char	ne_cr_default;

int getch(void)
{
	unsigned char c, d;

	SCR3 |= 0x10;
	while(!(SSR & 0x40)) {
		if(SSR & 0x38) {
			d = SSR;
			SSR = 0x40;
			return -1;
		}
	}
	c = RDR;
	SCR3 &= ~0x10;
	return c;
}

void putch(unsigned int c)
{
	while(!(SSR & 0x80));
	TDR = c;
	while(!(SSR & 0x04));
}

void scr_init() {
	int	i;

	PMR1 = 0x0e;
	SMR = 0;
	BRR = 51;
	SCR3 = 0;
	for(i = 0;i < 200;i++);
	SCR3 = 0x30;
	i = SSR;
	SSR = 0x80;
}

void print(char *str) {
	int i;

	i = 0;
	while(str[i] != 0) putch(str[i++]);
}

void puthexbyte(unsigned char h) {
	putch(hextbl[h >> 4]);
	putch(hextbl[h & 0xf]);
}

void putdecbyte(unsigned char d) {
	int	a, b, f;

	f = 0;
	b = (int)d & 0xff;
	a = (b % 1000) / 100;
	if(a > 0) f = 1;
	if(f == 1) putch(hextbl[a]);
	a = (b % 100) / 10;
	if(a > 0) f = 1;
	if(f == 1) putch(hextbl[a]);
	a = b % 10;
	putch(hextbl[a]);
}

void puthexint(unsigned int h) {
	putch(hextbl[(h >> 28) & 0xf]);
	putch(hextbl[(h >> 24) & 0xf]);
	putch(hextbl[(h >> 20) & 0xf]);
	putch(hextbl[(h >> 16) & 0xf]);
	putch(hextbl[(h >> 12) & 0xf]);
	putch(hextbl[(h >> 8) & 0xf]);
	putch(hextbl[(h >> 4) & 0xf]);
	putch(hextbl[h & 0xf]);
}

void putdecint(unsigned int d) {
	int	a, f;

	f = 0;
	a = (d % 10000000) / 1000000;
	if(a > 0) f = 1;
	if(f == 1) putch(hextbl[a]);
	a = (d % 1000000) / 100000;
	if(a > 0) f = 1;
	if(f == 1) putch(hextbl[a]);
	a = (d % 100000) / 10000;
	if(a > 0) f = 1;
	if(f == 1) putch(hextbl[a]);
	a = (d % 10000) / 1000;
	if(a > 0) f = 1;
	if(f == 1) putch(hextbl[a]);
	a = (d % 1000) / 100;
	if(a > 0) f = 1;
	if(f == 1) putch(hextbl[a]);
	a = (d % 100) / 10;
	if(a > 0) f = 1;
	if(f == 1) putch(hextbl[a]);
	a = d % 10;
	putch(hextbl[a]);
}

int string_check(char *str1, char *str2, int n) {
	int	i, ret;

	ret = 1;
	for(i = 0;i < n;i++) {
		if(str1[i] != str2[i]) {
			ret = 0;
			break;
		}
	}
	return ret;
}

void port_init() {
	PMR5 = 0;
	PCR5 = 0xff;
	PDR5 = 0x60;	/* x,RD=H,CS=H,A4-A0 */
	PMR1 |= 0x80;
	PCR1 = 0x60;
	PDR1 = 0x20;	/* WR=H LT=L */
}

void outportb(int port, int data) {
	int	addr;

	addr = port & 0x1f;
	PCR5 = 0xff;
	PDR5 = 0x40 + addr;	/* x,RD=H,CS=L,A4-A0 */
	PDR1 &= ~0x40;		/*******************/
	PDR1 |= 0x40;		/* 74HC573˥å */
	PDR1 &= ~0x40;		/*******************/
	PDR5 = data;
	PDR1 &= ~0x20;		/* WR=L */
	PDR5 = data;
	PDR1 |= 0x20;		/* WR=H */
	PDR5 = 0x60;		/* x,RD=H,CS=H,A4-A0 */
	PDR1 &= ~0x40;		/*******************/
	PDR1 |= 0x40;		/* 74HC573˥å */
	PDR1 &= ~0x40;		/*******************/
}

int inportb(int port) {
	int	addr, data;

	addr = port & 0x1f;
	PCR5 = 0xff;
	PDR5 = 0x00 + addr;	/* x,RD=L,CS=L,A4-A0 */
	PDR1 &= ~0x40;		/*******************/
	PDR1 |= 0x40;		/* 74HC573˥å */
	PCR5 = 0;
	data = PDR5;
	data = PDR5;
	data = PDR5;
	data = PDR5;
	data = PDR5;
	data = PDR5;
	PDR5 = 0x60;		/* x,RD=H,CS=H,A4-A0 */
	PDR1 &= ~0x40;		/*******************/
	PDR1 |= 0x40;		/* 74HC573˥å */
	return data;
}

void ne_writemem(unsigned char *src, unsigned int dest, unsigned int size) {
	int	i, a;

	/* DMA ߡå׵ǽͭ */
	outportb(NE_P0_COMMAND, NE_CR_RD2 | NE_CR_STA);
	
	/* ơ쥸ꥢ */
	outportb(NE_P0_ISR, NE_ISR_RDC);

	/* Хȿ */
	outportb(NE_P0_RBCR1, size / 0x100);
	outportb(NE_P0_RBCR0, size % 0x100);

	/* ž襢ɥ쥹 */
	outportb(NE_P0_RSAR1, dest / 0x100);
	outportb(NE_P0_RSAR0, dest % 0x100);

	/* ⡼å׵ǽͭ */
	outportb(NE_P0_COMMAND, NE_CR_RD1 | NE_CR_STA);

	/* ⡼ȥХåեإǡž */
	for(i = 0;i < size;i++) outportb(NE_ASIC_DATA, src[i]);
	
	/* ⡼DMAλޤԤ */
	while(!(inportb(NE_P0_ISR) & NE_ISR_RDC));
}

void ne_readmem(unsigned int src, unsigned char *dest, unsigned int size) {
	int	i, a;

	/* DMA ߡå׵ǽͭ */
	outportb(NE_P0_COMMAND, NE_CR_RD2 | NE_CR_STA);
	
	/* Хȿ */
	outportb(NE_P0_RBCR1, size / 0x100);
	outportb(NE_P0_RBCR0, size % 0x100);

	/* žɥ쥹 */
	outportb(NE_P0_RSAR1, src / 0x100);
	outportb(NE_P0_RSAR0, src % 0x100);

	/* ⡼ȼå׵ǽͭ */
	outportb(NE_P0_COMMAND, NE_CR_RD0 | NE_CR_STA);

	/* ⡼ȥХåեǡ */
	for(i = 0;i < size;i++) dest[i] = inportb(NE_ASIC_DATA);
}

int ne2000_probe() {
	int i, a, size;
	
	/* եȥꥻå */
	a = inportb(NE_ASIC_RESET);
	outportb(NE_ASIC_RESET, a);
	for(i = 0;i < 0x1000000;i++);	/* Ԥ */
puthexbyte(a);
	/* DMA ߡå׵ǽ */
	outportb(NE_P0_COMMAND, NE_CR_RD2 | NE_CR_STP);
	for(a = 0;a < 0x1000000;a++);	/* Ԥ */

	/* ѥåȤ˽񤫤ʤ褦ˤ */
	outportb(NE_P0_RCR, NE_RCR_MON);

	/* Хž롼ץХå⡼ */
	outportb(NE_P0_DCR, NE_DCR_FT1 | NE_DCR_LS);

	/* Хåեϥɥ쥹 */
	outportb(NE_P0_PSTART, NE_MEM_START);

	/* Хåեλɥ쥹 */
	outportb(NE_P0_PSTOP, NE_MEM_END);

	/* ХåեRAMΥå */
	ne_writemem(test_message, NE_MEM_START * NE_PAGE_SIZE, 20);
	ne_readmem(NE_MEM_START * NE_PAGE_SIZE, test_buffer, 20);
	test_buffer[20] = 0;
	if(strncmp(test_message, test_buffer, 20) != 0) return -1;

	/* EEPROMɤߤ */
	ne_readmem(0, eeprom, 32);
	for(i = 0;i < 6;i++) mac_address[i] = eeprom[i * 2];

	/* ߥơ쥸ꥢ */
	outportb(NE_P0_ISR, 0xff);

	return 0;
}

int main(void)
{
	int a;

	scr_init();
	port_init();
	if(ne2000_probe() == -1) {
		print("NE2000 is not found!\n");
		return -1;
	}
	print("Mac address of NE2000 is ");
	while(1);
}






