/* NE2000 쥸ݡ */

#define NE_BASE		0

#define NE_P0_COMMAND	NE_BASE+0
#define NE_P0_PSTART	NE_BASE+1
#define NE_P0_PSTOP	NE_BASE+2
#define NE_P0_BNRY	NE_BASE+3	/* Boundary Reg */
#define NE_P0_TSR	NE_BASE+4	/* Transmit Status Reg */
#define NE_P0_TPSR	NE_BASE+4	/* Transmit Page Start Address Reg */
#define NE_P0_TBCR0	NE_BASE+5	/* Transmit Byte Counter Reg */
#define NE_P0_NCR	NE_BASE+5	/* Nubmer of Collisions */
#define NE_P0_TBCR1	NE_BASE+6
#define NE_P0_ISR	NE_BASE+7	/* Interrupt Status Reg */
#define NE_P0_RSAR0	NE_BASE+8	/* Remote Start Address Reg */
#define NE_P0_RSAR1	NE_BASE+9
#define NE_P0_RBCR0	NE_BASE+10	/* Remote Byte Count Reg */
#define NE_P0_RBCR1	NE_BASE+11
#define NE_P0_RSR	NE_BASE+12	/* Receive Status Reg */
#define NE_P0_RCR	NE_BASE+12	/* Receive Configuration Reg */
#define NE_P0_TCR	NE_BASE+13	/* Transmit Configuration Reg */
#define NE_P0_DCR	NE_BASE+14	/* Data Configuration Reg */
#define NE_P0_IMR	NE_BASE+15	/* Interrupt Mask Reg */
#define NE_P0_CNTR0	NE_BASE+13
#define NE_P0_CNTR1	NE_BASE+14
#define NE_P0_CNTR2	NE_BASE+15
#define NE_P1_COMMAND	NE_BASE+0
#define NE_P1_PAR0	NE_BASE+1	/* Physical Addres Reg */
#define NE_P1_PAR1	NE_BASE+2
#define NE_P1_PAR2	NE_BASE+3
#define NE_P1_PAR3	NE_BASE+4
#define NE_P1_PAR4	NE_BASE+5
#define NE_P1_PAR5	NE_BASE+6
#define NE_P1_CURR	NE_BASE+7	/* Current Page Reg */
#define NE_P1_MAR0	NE_BASE+8	/* Multicast Address Reg */

#define NE_ASIC		NE_BASE+16

#define NE_ASIC_DATA	NE_ASIC		/* data port */
#define NE_ASIC_RESET	NE_ASIC+15	/* reset port */

/* NE2000  */
#define	NE_CR_PS0	0x00	/* Page 0 Select   */
#define	NE_CR_PS1	0x40	/* Page 1 Select   */
#define	NE_CR_PS2	0x80	/* Page 2 Select   */
#define	NE_CR_RD0	0x08	/********************** 000:DON'T, 001:read  */
#define	NE_CR_RD1	0x10	/* Remote DMA Control * 010:write, 011:trans */
#define NE_CR_RD2	0x20	/********************** 1xx:disable          */
#define NE_CR_TXP	0x04	/* Transmit packet */
#define NE_CR_STA	0x02	/* start	   */
#define	NE_CR_STP	0x01	/* stop		   */

#define	NE_RCR_SEP	0x01	/* accept error packet */
#define	NE_RCR_AR	0x02	/* accept tiny packet */
#define	NE_RCR_AB	0x04	/* accept broadcast */
#define	NE_RCR_PRO	0x10	/* accept all */
#define	NE_RCR_MON	0x20	/* monitor mode */

#define	NE_DCR_FT0	0x20	/* fifo  */
#define	NE_DCR_FT1	0x40	/* fifo  */
#define	NE_DCR_AR	0x10	/* Auto remote */
#define	NE_DCR_WTS	0x01	/* Word Transfer select */
#define	NE_DCR_BOS	0x02	/* Byte Transfer select */
#define	NE_DCR_LAS	0x04	/* Long Transfer select */
#define	NE_DCR_LS	0x08	/* Loopback select */

#define	NE_ISR_PRX	0x01	/* successful receive */
#define	NE_ISR_PTX	0x02	/* successful trasmit */
#define	NE_ISR_RXE	0x04	/* receive error */
#define	NE_ISR_TXE	0x08	/* transmit error */
#define	NE_ISR_OVW	0x10	/* overflow */
#define	NE_ISR_CNT	0x20	/* counter overflow */
#define	NE_ISR_RDC	0x40	/* Remote DMA complete */
#define	NE_ISR_RST	0x80	/* reset */

#define	NE_IMR_PRXE	0x01	/* successful receive */
#define	NE_IMR_PTXE	0x02	/* successful trasmit */
#define	NE_IMR_RXEE	0x04	/* receive error */
#define	NE_IMR_TXEE	0x08	/* transmit error */
#define	NE_IMR_OVWE	0x10	/* overflow */
#define	NE_IMR_CNTE	0x20	/* counter overflow */
#define	NE_IMR_RDCE	0x40	/* Remote DMA complete */

#define	NE_RSTAT_PRX	0x01	/* successful receive */
#define	NE_RSTAT_CRC	0x02	/* CRC error */
#define	NE_RSTAT_FAE	0x04	/* Frame alignment error */
#define	NE_RSTAT_OVER	0x08	/* overflow */

#define	NE_TSR_PTX	0x01	/* Transmit complete */
#define	NE_TSR_ABT	0x08	/* Transmit Aborted */

#define	NE_TCR_LB0	0x02	/* Internal loopback */
#define	NE_TCR_LB1	0x02	/* Internal loopback */

/* NE2000 ΰ */
#define	NE_MEM_START	 0x40	/* Хåե곫ϥڡֹ	(ɥ쥹4000h) */
#define	NE_MEM_END	 0x80	/* Хåե꽪λڡֹ (ɥ쥹8000h) */
#define	NE_PAGE_SIZE	 256	/* ڡΥХȿ */
#define	NE_TX_PAGE_START 0x46	/* Хåեϥڡֹ */
#define	NE_RX_PAGE_START 0x4c	/* Хåեϥڡֹ */
#define	NE_RX_PAGE_STOP  0x80	/* Хåեλڡֹ */

/* ͥå */
#define	ETHER_HEADER_SIZE	14	/* إå */
#define	ETHER_MIN_PACKET	64	/* Ǿѥåȥ */
#define	ETHER_MAX_PACKET	1514	/* ѥåȥ */

/* ե졼ॿ */
#define ARP_TYPE	0x806
#define IP_TYPE		0x800

#define IP_ICMP		1
#define IP_UDP		17
#define IP_TCP		6

