/********************************/
/* H8/3664FΥץץ */
/* Copyleft,2000,Yukio Mituiwa  */
/********************************/
#include <stdio.h>
#include "../reg3664.h"

void init() {
	PMR5 = 0x00;	/* P50-P55 is general I/O */
	PCR5 = 0xc0;	/* P50-P55 is input, P56-P57 is output */
	PUCR5 = 0x1f;	/* P50-P54 is pull-up */
	PCR7 = 0x70;	/* P74-P76 is input */
}

void out7seg(int data) {
	int second, first;
	
	first = data % 10;
	second = data / 10;
	IRR1 &= ~0x40;
	PDR5 = (first & 0x03) << 6;
	PDR7 = (first & 0x0c) << 2;
	PDR7 |= 0x40;
	PDR5 = (second & 0x03) << 6;
	PDR7 = ((second & 0x0c) << 2) | 0x40;
}

int main(void)
{
	init();
	out7seg(0);
/*	TMA = 0x18;
	IENR1 = 0x40;
	asm("andc.b\t#127,ccr\n");
	while(1);*/
}

#pragma interrupt
void int_timera() {
	static int data = 0;

	IRR1 &= ~0x40;
	if(data >= 59) data = 0;
	else data++;
	out7seg(data);
}
