/***************************************/
/* H8-3048/3664/3067˥ץ */
/*         Copyleft,2001,Yukio Mituiwa */
/***************************************/
#include <string.h>
#ifdef H8_3048
  #include "reg3048.h"
  #define CPUID	"3048"
#endif
#ifdef H8_3664
  #include "reg3664.h"
  #define CPUID	"3664"
#endif
#ifdef H8_3067
  #include "reg3067.h"
  #define CPUID	"3067"
#endif
#define MAX_BUF	80
#define MAX_ARG	30
static char errmsg[] = "ޥɤ¸ߤʤǤ";
static char hextbl[] = "0123456789ABCDEF";
static int  *sysargs, callnum, ta_count;
int  jump, spsave;

int getch(void)
{
#ifdef H8_3048
	unsigned char c;

	SCR1 |= 0x10;
	do {
		if(SSR1 & 0x38) return -1;
	} while(!(SSR1 & 0x40)) ;
	SSR1 &= ~0x40;
	c = RDR1;
	SCR1 &= ~0x10;
	return (unsigned int)c;
#endif
#ifdef H8_3664
	unsigned char c, d;

	SCR3 |= 0x10;
	while(!(SSR & 0x40)) {
		if(SSR & 0x38) {
			d = SSR;
			SSR = 0x40;
			return -1;
		}
	}
	c = RDR;
	SCR3 &= ~0x10;
	return c;
#endif
#ifdef H8_3067
	unsigned char c;

	SCR1 |= 0x10;
	while(!(SSR1 & 0x78));
	if(SSR1 & 0x40) {
		c = RDR1;
		SSR1 &= ~0x40;
	} else {
		SSR1 = 0xc7;
		return -1;
	}
	SCR1 &= ~0x10;
	return c;
#endif
}

void putch(unsigned int c)
{
#ifdef H8_3048
	SCR1 |= 0x20;
	while(!(SSR1 & 0x80));
	TDR1 = c;
	SSR1 &= ~0x80;
	while(!(SSR1 & 0x04));
	SCR1 &= ~0x20;
#endif
#ifdef H8_3664
	while(!(SSR & 0x80));
	TDR = c;
	while(!(SSR & 0x04));
#endif
#ifdef H8_3067
	while(!(SSR1 & 0x80));
	TDR1 = c;
	SSR1 &= ~0x80;
	while(!(SSR1 & 0x04));
#endif
}

void print(char *str) {
	int i;

	i = 0;
	while(str[i] != 0) putch(str[i++]);
}

void putstr(char *str) {
	int i;

	i = 0;
	while(str[i] != 0) putch(str[i++]);
	putch(0);
}

void getstr(char *str) {
	int	n,c;

	n = 0;
	c = getch();
	while(c != '\n' && n < MAX_BUF) {
		str[n++] = c;
		c = getch();
	}
	str[n] = 0;
}

int atohex(char *str) {
	int	i, n;
	unsigned int c, val;

	val = i = 0;
	while(str[i] != 0 && i < 8) {
		val <<= 4;
		c = str[i];
		if(c >= '0' && c <= '9') {
			val += c - '0';
		} else if(c >= 'a' && c <= 'f') {
			val += c - 'a' + 10;
		} else if(c >= 'A' && c <= 'F') {
			val += c - 'A' + 10;
		} else {
			return -1;
		}
		i++;
	}
	return val;
}

void puthexbyte(unsigned char h) {
	putch(hextbl[h >> 4]);
	putch(hextbl[h & 0xf]);
}

void puthexint(unsigned int h) {
	putch(hextbl[(h >> 28) & 0xf]);
	putch(hextbl[(h >> 24) & 0xf]);
	putch(hextbl[(h >> 20) & 0xf]);
	putch(hextbl[(h >> 16) & 0xf]);
	putch(hextbl[(h >> 12) & 0xf]);
	putch(hextbl[(h >> 8) & 0xf]);
	putch(hextbl[(h >> 4) & 0xf]);
	putch(hextbl[h & 0xf]);
}

void init() {
#ifdef H8_3048
	SMR1 = 0;
	BRR1 = 51;
	SCR1 = 0;
	SSR1 = 0;
	P1DDR = 0xff;	/* A0-7   is enable */
	P2DDR = 0xff;	/* A8-15  is enable */
	P5DDR = 0xff;	/* A16-19 is enable */
	P8DDR = 0xff;	/* CS is enable */
#endif
#ifdef H8_3664
	int	i;

	/* SCRν */
	PMR1 = 0x0e;
	SMR = 0;
	BRR = 51;
	SCR3 = 0;
	for(i = 0;i < 200;i++);
	SCR3 = 0x30;
	i = SSR;
	SSR = 0x80;
#endif
#ifdef H8_3067
	/* SCI1ν */
	int	i;

	SCR1 = 0;
	SMR1 = 0;
	BRR1 = 64;	/* 20MHz */
	for(i = 0;i < 280;i++);
	SCR1 = 0x30;
	i = SSR1;
	SSR1 = 0x80;
	P1DDR = 0xff;	/* A0-7   is enable */
	P2DDR = 0xff;	/* A8-15  is enable */
	P5DDR = 0x01;	/* A16 is enable */
	P8DDR = 0x0c;	/* CS is enable */
#endif
}

int main(void)
{
	int	count, i, num, addr, data;
	char	com[MAX_BUF], *coms[MAX_ARG];
	unsigned char *p;

	init();
	putstr("褦H8/" CPUID "F˥!!");
	while(1) {
		getstr(com);
		i = count = 0;
		coms[count++] = &(com[i]);
		while(com[i] != 0) {
			if(com[i] == ' ') {
				com[i] = 0;
				coms[count++] = &(com[i + 1]);
			}
			i++;
		}
		if(count >= MAX_ARG) {
			putstr(errmsg);
		} else if(strcmp(coms[0], "dump") == 0 && count == 2) {
			num = atohex(coms[1]);
			if(num == -1) {
				putstr(errmsg);
			} else {
				for(i = 0;i < 64;i++) {
					if((i % 16) == 0) {
						print("\n");
						puthexint(num);
						print(" : ");
					}
					if((i % 16) == 8) print("  ");
					p = (unsigned char *)num;
					puthexbyte(*p);
					num++;
				}
				putstr("\n");
			}
		} else if(strcmp(coms[0], "setbyte") == 0 && count == 3) {
			addr = atohex(coms[1]);
			num = atohex(coms[2]);
			if(addr == -1 || num == -1) {
				putstr(errmsg);
			} else {
				p = (unsigned char *)addr;
				puthexbyte((unsigned char)num);
				print("  ");
				puthexbyte(*p);
				*p = num;
				putstr("ѹޤ\n");
			}
		} else if(strcmp(coms[0], "setdata") == 0 && count >= 3) {
			addr = atohex(coms[1]);
			num = atohex(coms[2]);
			if(addr == -1 || num == -1 || count != num + 3) {
				putstr(errmsg);
			} else {
				p = (unsigned char *)addr;
				for(i = 0;i < num;i++) {
					data = atohex(coms[i + 3]);
					*p = data;					
					p++;
				}
				putstr("data򹹿ޤ\n");
			}
		} else if(strcmp(coms[0], "clear") == 0 && count == 3) {
			addr = atohex(coms[1]);
			num = atohex(coms[2]);
			if(addr == -1 || num == -1) {
				putstr(errmsg);
			} else {
				p = (unsigned char *)addr;
				for(i = 0;i < num;i++) {
					*p = 0;
					p++;
				}
				putstr("ޤ\n");
			}
		} else if(strcmp(coms[0], "exec") == 0 && count == 2) {
			jump = atohex(coms[1]);
			asm("mov.l\tsp,@_spsave");
			asm("mov.l\t@_jump,er0");
			asm("jsr\t@er0");
			asm("orc.b\t#128,ccr\n");
			asm("mov.l\t@_spsave,sp");
			putstr("ץ¹Ԥޤ\n");
		} else {
			putstr(errmsg);
		}
	}
}

#ifdef H8_3067
#pragma interrupt
void int_ovi0() {
	asm("mov.l\t@_ramvec,er0");
	asm("jsr\t@er0");
}
#endif
