#define	LINUX
#undef	FreeBSD

#include	<stdio.h>
#include	<sys/stat.h>
#include	<unistd.h>
#include	<fcntl.h>
#define	RSLINE	"/dev/ttyS0"
#ifdef LINUX
 #include <termios.h>
 #define sgttyb termios
 #define stty(fd,term) tcsetattr(fd,TCSANOW,term)
#endif
#ifdef FreeBSD
 #include <sgtty.h>
#endif

unsigned char sPort[256], rsbuf[1024];
struct sgttyb TheTty;
int TheFd;
FILE *fp;

int putbyte(int c) {
	int	s;

	rsbuf[0] = c;
	if((s = write(TheFd,rsbuf,1)) == -1) {
		fprintf(stderr, "write error\n" );
		exit(-1);
	}
	return s;
}	

int getb() {
	int	s;

	if((s = read(TheFd,rsbuf,1)) == -1) {
		fprintf(stderr, "read error\n" );
		exit(-1);
	}
	return s;
}	

int getbyte() {
	int	s;

	do {
		if((s = read(TheFd,rsbuf,1)) == -1) {
			fprintf(stderr, "read error\n" );
			exit(-1);
		}
	} while(s < 1);
	return rsbuf[0];
}	

void rs_puts(char *str) {
	char *p;

	p = str;
	while(*p != 0) putbyte(*(p++));
	putbyte('\n');
}

void rs_gets(char *str) {
	int	c, n;

	c = getbyte();
	n = 0;
	while (c != 0) {
		str[n++] = c;
		c = getbyte();
	}
	str[n] = 0;
}

void rs_gets_disp() {
	int	c;

	do {
		c = getbyte();
		putchar(c);
		fflush(stdout);
	} while (c != 0);
	putchar('\n');
}

int main(argc,argv)
char **argv;
{
	int	i, n, count, addr, data, size;
	char	rsbuf[1024], combuf[1024], numbuf[9], cpuid[16], *name, *ptr, *rsp;
	FILE	*fp;
	
	strcpy(sPort,RSLINE);
	switch(argc) {
	case 2:
		strcpy(sPort,argv[1]);
	case 1:
		break;
	default:
		fprintf(stderr, "option error!!\n");
		return -1;
	}

	if((TheFd=open( sPort , O_RDWR)) == -1){
		fprintf(stderr, "can't open %s\n", sPort);
		return -1;
	}
#ifdef LINUX
	tcsetpgrp(TheFd,getpgrp());
	tcgetattr(TheFd,&TheTty);
	cfsetispeed(&TheTty,9600);
	cfsetospeed(&TheTty,9600);
	TheTty.c_cflag |= HUPCL | CLOCAL ;
	TheTty.c_cflag &= ~( PARENB | CSTOPB );
	cfmakeraw(&TheTty);
#endif
#ifdef FreeBSD
	TheTty.sg_ispeed=B9600;
	TheTty.sg_ospeed=B9600;
	TheTty.sg_flags=RAW;
#endif
	if(stty(TheFd, &TheTty ) == -1){
		fprintf(stderr, "stty error\n" );
		return -1;
	}
	strcpy(cpuid, "H8/****F> ");
	rs_gets(rsbuf);
	for(i = 0;i < 4;i++) cpuid[i + 3] = rsbuf[i + 11];
	puts(rsbuf);
	while(1) {
		printf("%s", cpuid);
		fgets(combuf, 128, stdin);
		combuf[strlen(combuf) - 1] = 0;
		if(strncmp(combuf, "quit", 4) == 0) break;
		if(strncmp(combuf, "write", 5) == 0) {
			name = combuf + 6;
			if((fp = fopen(name, "r")) == NULL) {
				puts("ե뤬ߤĤޤ");
			} else {
				fgets(combuf, 128, fp);
				printf("񤭹");
				while(!feof(fp)) {
					if(combuf[0] != 'S') {
						fgets(combuf, 128, fp);
						continue;
					}
					numbuf[0] = combuf[1];
					numbuf[1] = 0;
					size = atoi(numbuf);
					if(size < 1 || size > 3) {
						fgets(combuf, 128, fp);
						continue;
					}
					numbuf[0] = combuf[2];
					numbuf[1] = combuf[3];
					numbuf[2] = 0;
					sscanf(numbuf, "%x", &count);
					ptr = combuf + 4;
					for(i = 0;i < size + 1;i++) {
						numbuf[i * 2] = *(ptr++);
						numbuf[i * 2 + 1] = *(ptr++);
					}
					numbuf[i * 2] = 0;
					sscanf(numbuf, "%x", &addr);
					sprintf(rsbuf, "setdata %x %x", addr, count - 2 - size);
					rsp = &(rsbuf[strlen(rsbuf)]); 
					for(i = 0;i < count - 2 - size;i++) {
						*(rsp++) = ' ';
						*(rsp++) = *(ptr++);
						*(rsp++) = *(ptr++);
					}
					*rsp = 0;
					rs_puts(rsbuf);
					rs_gets(rsbuf);
					putchar('.');fflush(stdout);
					fgets(combuf, 128, fp);
				}
				fclose(fp);
				puts("\n񤭹ߤλޤ");
			}
		} else {
			rs_puts(combuf);
			rs_gets_disp();
		}
	}
	puts("H8λޤ");
}
