/********************************/
/* H8/3664FΥץץ */
/* Copyleft,2000,Yukio Mituiwa  */
/********************************/
#include <stdio.h>
#include "../registor.h"

void init() {
	PMR1 = 0x0f;	/* P14-P17 is general I/O, TXD, TMOW */
	PCR1 = 0x00;	/* P14-P17 is input */
	PUCR1 = 0x88;	/* P17 is pull-up */
	PCR8 = 0xff;	/* P80-P87 is output */
	PMR5 = 0x00;	/* P50-P55 is general I/O */
	PCR5 = 0xc0;	/* P50-P55 is input, P56-P57 is output */
	PUCR5 = 0x1f;	/* P50-P54 is pull-up */
	PCR7 = 0x70;	/* P74-P76 is input */
	ADCR = 0x7e;	/* triger disable */
	ADCSR = 0x03;	/* Use AN3(ADDRD) */
}

void out7seg(int data) {
	int second, first;
	
	first = data % 10;
	second = data / 10;
	IRR1 &= ~0x40;
	PDR5 = (first & 0x03) << 6;
	PDR7 = (first & 0x0c) << 2;
	PDR7 |= 0x40;
	PDR5 = (second & 0x03) << 6;
	PDR7 = ((second & 0x0c) << 2) | 0x40;
}

int main(void)
{
	unsigned int data;

	init();
	TMA = 0x1a;
	IENR1 = 0x40;
	asm("andc.b\t#127,ccr\n");
	while(1) {
		data = ~PDR1;
		PDR8 = (data & 0x80) ? 0xff : 0;
	}
}

#pragma interrupt
void int_timera() {
	int data;

	IRR1 &= ~0x40;
	data = ADCSR;	/* dummy read */
	ADCSR |= 0x20;
	while(!(ADCSR & 0x80));
	data = (ADDRD >> 6) / 10;
	out7seg(data);
}
