/* h8reg.h : port address of internal registers */

#define MDCR  (*(volatile unsigned char *)0xfee011)
#define SYSCR (*(volatile unsigned char *)0xfee012)
#define BRCR  (*(volatile unsigned char *)0xfee013)
#define CSCR  (*(volatile unsigned char *)0xfee01f)
#define ABWCR (*(volatile unsigned char *)0xfee020)
#define ASTCR (*(volatile unsigned char *)0xfee021)
#define WCRH  (*(volatile unsigned char *)0xfee022)
#define WCRL  (*(volatile unsigned char *)0xfee023)
#define BCR   (*(volatile unsigned char *)0xfee024)
#define RAMCR (*(volatile unsigned char *)0xfee077)
#define FLMCR (*(volatile unsigned char *)0xfee030)
#define EBR   (*(volatile unsigned char *)0xfee032)
#define FLMSR (*(volatile unsigned char *)0xfee07d)
#define TSTR  (*(volatile unsigned char *)0xffff60)
#define TSNC  (*(volatile unsigned char *)0xffff61)
#define TMDR  (*(volatile unsigned char *)0xffff62)
#define TOLR  (*(volatile unsigned char *)0xffff63)
#define TISRA (*(volatile unsigned char *)0xffff64)
#define TISRB (*(volatile unsigned char *)0xffff65)
#define TISRC (*(volatile unsigned char *)0xffff66)
#define TCR0  (*(volatile unsigned char *)0xffff68)
#define TIOR0 (*(volatile unsigned char *)0xffff69)
#define TCNT0 (*(volatile unsigned short *)0xffff6a)
#define GRA0 (*(volatile unsigned short *)0xffff6c)
#define GRB0 (*(volatile unsigned short *)0xffff6e)
#define TCR1  (*(volatile unsigned char *)0xffff70)
#define TIOR1 (*(volatile unsigned char *)0xffff71)
#define TCNT1 (*(volatile unsigned short *)0xffff72)
#define GRA1 (*(volatile unsigned short *)0xffff74)
#define GRB1 (*(volatile unsigned short *)0xffff76)
#define TCR2  (*(volatile unsigned char *)0xffff78)
#define TIOR2 (*(volatile unsigned char *)0xffff79)
#define TCNT2 (*(volatile unsigned short *)0xffff7a)
#define GRA2 (*(volatile unsigned short *)0xffff7c)
#define GRB2 (*(volatile unsigned short *)0xffff7e)
#define TCSR (*(volatile unsigned short *)0xffff8c)
#define TCNT (*(volatile unsigned short *)0xffff8d)

#define T8TCR0  (*(volatile unsigned char *)0xffff80)
#define T8TCR1  (*(volatile unsigned char *)0xffff81)

#define SMR0 (*(volatile unsigned char *)0xffffb0)
#define BRR0 (*(volatile unsigned char *)0xffffb1)
#define SCR0 (*(volatile unsigned char *)0xffffb2)
#define TDR0 (*(volatile unsigned char *)0xffffb3)
#define SSR0 (*(volatile unsigned char *)0xffffb4)
#define RDR0 (*(volatile unsigned char *)0xffffb5)
#define SMR1 (*(volatile unsigned char *)0xffffb8)
#define BRR1 (*(volatile unsigned char *)0xffffb9)
#define SCR1 (*(volatile unsigned char *)0xffffba)
#define TDR1 (*(volatile unsigned char *)0xffffbb)
#define SSR1 (*(volatile unsigned char *)0xffffbc)
#define RDR1 (*(volatile unsigned char *)0xffffbd)
#define SMR1 (*(volatile unsigned char *)0xffffb8)
#define SMR2 (*(volatile unsigned char *)0xffffc0)
#define BRR2 (*(volatile unsigned char *)0xffffc1)
#define SCR2 (*(volatile unsigned char *)0xffffc2)
#define TDR2 (*(volatile unsigned char *)0xffffc3)
#define SSR2 (*(volatile unsigned char *)0xffffc4)
#define RDR2 (*(volatile unsigned char *)0xffffc5)

#define P1DDR (*(volatile unsigned char *)0xfee000)
#define P2DDR (*(volatile unsigned char *)0xfee001)
#define P3DDR (*(volatile unsigned char *)0xfee002)
#define P4DDR (*(volatile unsigned char *)0xfee003)
#define P5DDR (*(volatile unsigned char *)0xfee004)
#define P6DDR (*(volatile unsigned char *)0xfee005)
#define P7DDR (*(volatile unsigned char *)0xfee006)
#define P8DDR (*(volatile unsigned char *)0xfee007)
#define P9DDR (*(volatile unsigned char *)0xfee008)
#define PADDR (*(volatile unsigned char *)0xfee009)
#define PBDDR (*(volatile unsigned char *)0xfee00a)
#define P2PCR (*(volatile unsigned char *)0xfee03c)
#define P4PCR (*(volatile unsigned char *)0xfee03e)
#define P5PCR (*(volatile unsigned char *)0xfee03f)
#define P1DR  (*(volatile unsigned char *)0xffffd0)
#define P2DR  (*(volatile unsigned char *)0xffffd1)
#define P3DR  (*(volatile unsigned char *)0xffffd2)
#define P4DR  (*(volatile unsigned char *)0xffffd3)
#define P5DR  (*(volatile unsigned char *)0xffffd4)
#define P6DR  (*(volatile unsigned char *)0xffffd5)
#define P7DR  (*(volatile unsigned char *)0xffffd6)
#define P8DR  (*(volatile unsigned char *)0xffffd7)
#define P9DR  (*(volatile unsigned char *)0xffffd8)
#define PADR  (*(volatile unsigned char *)0xffffd9)
#define PBDR  (*(volatile unsigned char *)0xffffda)
