#include "../reg3664.h"

void init() {
	int	i;

	/* SCRν */
	PMR1 = 0x0e;
	SMR = 0;
	BRR = 51;
	SCR3 = 0;
	for(i = 0;i < 200;i++);
	SCR3 = 0x30;
	i = SSR;
	SSR = 0x80;
	/* timer A ν */
	PMR5 = 0x00;	/* P50-P55 is I/O */
	PCR5 = 0x00;	/* P50-P57 is input */
	PCR8 = 0xff;	/* P80-P87 is output */
}

int main(void) {
	init();
	TMA = 0x18 + 3;	/* 1/256*/
	IENR1 = 0x40;
	asm("andc.b\t#127,ccr\n");
	while(1);
}

#pragma interrupt

void int_timera() {
	static int count = 0;
	static int patten[4] = {0x09,0x05,0x06,0x0a};
	if(count >= 3)
		count = 0;
	else
		count++;
	PDR8 = patten[count];
	IRR1 &= ~0x40;
}
